import refreshTokenHelper from "../../../../../utils/refreshTokenHelper"
import forceLogoutHelper from "../../../../../utils/forceLogoutHelper"
import errorHandlingHelper from "../../../../../utils/errorHandlingHelper"

const handleFunc = async (event: any, authToken: any = null) => {
  let data: any = {}
  const config = useRuntimeConfig()
  const token = authToken ?? await getTokenHelper(event)
  const body = await readBody(event)

  if(body.id) {
    const res: any = await event.context.fetch('models/ad_user_substitute/'+body.id, 'PUT', token, {
      Substitute_ID: {
        id: body.substituteId,
        tableName: 'AD_User'
      },
      name: body.name,
      description: body.description,
      validFrom: body.validFrom,
      validTo: body.validTo,
      isActive: body.isActive,
      tableName: 'AD_User_Substitute'
    })
    if(res) {
      data = res
      data['status'] = 200
      data['message'] = ''
    }
  }

  return data
}

export default defineEventHandler(async (event) => {
  let data: any = {}

  try {
    data = await handleFunc(event)
  } catch(err: any) {
    try {
      let authToken: any = await refreshTokenHelper(event)
      data = await handleFunc(event, authToken)
    } catch(error: any) {
      data = {
        //@ts-ignore
        status: error.status || error.statusCode || 500,
        //@ts-ignore
        message: error.detail || error.message || error.statusMessage
      }
      /*if(data.status < 500) {
        setCookie(event, 'user', null)
      }*/
    }
  }

  return data
})